

                                          //------CCI EA Version 2.0-------// 





extern double Lots=0.10;
extern bool EnableMM=false;
extern double Risk=5;  // 5%
extern int StopLoss=70;     //if set to 0 then it is disabled
extern int TakeProfit=0;   //if set to 0 then it is disabled
extern int TrailingStop=0;  //if set to 0 then it is disabled 
extern int BreakEven=0;    //if set to 0 then it is disabled

extern int OpenTime = -1; //time in format HHMM Ex: 14:32 is 1432 //if set to -1 then it is disabled
extern int CloseTime = -1; //time in format HHMM Ex: 14:32 is 1432 //if set to -1 then it is disabled
extern bool CloseTradesAfterTimeLimit = true;
extern int FridayCloseTime = -1; // if set to -1 it is disabled  - time in format HHmm

extern int CCI_Period = 110;
extern int CCI_Price = PRICE_CLOSE;
extern double Buy_Point = -50;
extern double Sell_Point = 50;
extern int Trade_Bar=2;  // Number of bars to wait to place trade after signal has been hit.


extern int Slippage=3;
extern int Magic_Number=500;


datetime last_t=0;
string com="CCI EA 2.0";

int init(){
   return(0);
}

int deinit(){return(0);}
int start()
  {
   int i=0;
   double ask,bid;
   double SL=0,TP=0;
   bool up=false;
   bool dn=false;
   int t1=TimeHour(TimeCurrent())*100+TimeMinute(TimeCurrent());
   int mult=1;
   if ( ((StringFind(Symbol(),"JPY",0)!=-1 || StringFind(Symbol(),"jpy",0)!=-1) && Point<0.01) ||
        ((StringFind(Symbol(),"JPY",0)==-1 || StringFind(Symbol(),"jpy",0)==-1) && Point<0.0001))
      mult=10;   
   Print(t1);
   if ((t1<CloseTime || CloseTime==-1) && (t1>=OpenTime || OpenTime==-1)) {
      double cci0 = iCCI(Symbol(),0,CCI_Period,CCI_Price,Trade_Bar);
      double cci1 = iCCI(Symbol(),0,CCI_Period,CCI_Price,Trade_Bar+1);

      if (cci0>Buy_Point && cci1<=Buy_Point){
         up=true;
         dn=false;
      }
   
      if (cci0<Sell_Point && cci1>=Sell_Point){
         dn=true;
         up=false;
      }
      if (TotalOrders(Magic_Number)>0){
         if (TrailingStop>0) tr(Magic_Number,TrailingStop*mult);
         if (BreakEven>0) be(Magic_Number,BreakEven*mult);   
         for (int t=0;t<OrdersTotal();t++){
            OrderSelect(t,SELECT_BY_POS);
            if (OrderType()==Magic_Number){
               break;
            }
         }
         if (OrderType()==OP_BUY && dn){
            OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),Slippage,Pink);
         }
         if (OrderType()==OP_SELL && up){
            OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage,Pink);
         }
      }   
      if (EnableMM && StopLoss>0){
         double Lot=FRisk_MM(Lots,StopLoss,Risk/100);
      }else{
         Lot=Lots;
      }


      if (TotalOrders(Magic_Number)==0 && Time[0]>last_t ){
         if (up ){
            RefreshRates();
            ask=MarketInfo(Symbol(),MODE_ASK);
            if (StopLoss>0) {SL=NormalizeDouble(ask-StopLoss*Point*mult,Digits);}else{SL=0;}
            if (TakeProfit>0) {TP=NormalizeDouble(ask+TakeProfit*Point*mult,Digits);}else{TP=0;}
            if (OrderSend(Symbol(),OP_BUY,Lot,NormalizeDouble(ask,Digits),Slippage,SL,TP,com+Period(),Magic_Number,0,Blue)==-1) {
                  i=GetLastError();
                  if (i!=1 && i!=0) Print("Buy Error :"+error(i)+" at "+Symbol()+" "+Period());                 
            }else{
               last_t=Time[0];
               return(0);
            }
         }
         if (dn ){
            RefreshRates();
            bid=MarketInfo(Symbol(),MODE_BID);
            if (StopLoss>0) {SL=NormalizeDouble(bid+StopLoss*Point*mult,Digits);}else{SL=0;}
            if (TakeProfit>0) {TP=NormalizeDouble(bid-TakeProfit*Point*mult,Digits);}else{TP=0;}
            if (OrderSend(Symbol(),OP_SELL,Lot,NormalizeDouble(bid,Digits),Slippage,SL,TP,com+Period(),Magic_Number,0,Red)==-1) {
                  i=GetLastError();
                  if (i!=1 && i!=0) Print("Sell Error :"+error(i)+" at "+Symbol()+" "+Period());                 
            }else{
               last_t=Time[0];
               return(0);
            }
         }         
      }
   }else{
      if (t1 >= CloseTime && CloseTime !=-1 && CloseTradesAfterTimeLimit) {
         close_all(Magic_Number);
      }
   }   
   
   if (t1>=FridayCloseTime && FridayCloseTime!=-1 && DayOfWeek()==5){
      close_all(Magic_Number);
   }
   
   return(0);   
  }



void tr(int magic,int triling_i){  
   int mult=1;
   if ( ((StringFind(Symbol(),"JPY",0)!=-1 || StringFind(Symbol(),"jpy",0)!=-1) && Point<0.01) ||
        ((StringFind(Symbol(),"JPY",0)==-1 || StringFind(Symbol(),"jpy",0)==-1) && Point<0.0001))
      mult=10;   
  for (int k=0;k<OrdersTotal();k++){
    OrderSelect(k,SELECT_BY_POS);
    if (OrderMagicNumber()==magic){        
      if (OrderType()==OP_BUY && NormalizeDouble(Ask-OrderOpenPrice(),Digits)>=triling_i*Point*mult && OrderStopLoss()<NormalizeDouble(Ask-triling_i*Point*mult,Digits)) {
         if (!OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask-triling_i*Point*mult,Digits),OrderTakeProfit(),0,Blue)){
            Print("Trailing stop error Buy :"+error(GetLastError()));
         }    
      }
      if (OrderType()==OP_SELL && NormalizeDouble(Bid+triling_i*Point*mult,Digits)<=OrderOpenPrice() && (OrderStopLoss()>NormalizeDouble(Bid+triling_i*Point*mult,Digits) || OrderStopLoss()==0)) {
         if (!OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid+triling_i*Point*mult,Digits),OrderTakeProfit(),0,Red)){
            Print("Trailing stop error Sell :"+error(GetLastError()));  
         }
      }
    }
  }
}
void be(int m,int bep){
   int mult=1;
   if ( ((StringFind(Symbol(),"JPY",0)!=-1 || StringFind(Symbol(),"jpy",0)!=-1) && Point<0.01) ||
        ((StringFind(Symbol(),"JPY",0)==-1 || StringFind(Symbol(),"jpy",0)==-1) && Point<0.0001))
      mult=10;   
   for (int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS);
      if (OrderMagicNumber()==m){
         if (OrderType()==OP_BUY && OrderStopLoss()<OrderOpenPrice() && Bid-OrderOpenPrice()>=bep*Point*mult){
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0);
         }
         if (OrderType()==OP_SELL && (OrderStopLoss()>OrderOpenPrice() || OrderStopLoss()==0) && OrderOpenPrice()-Ask>=bep*Point*mult){
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0);
         }
      }
   }
}

void close_all(int m){
   bool g= false;
   while (!g){
      g=true;
      for (int i=0;i<OrdersTotal();i++){
         OrderSelect(i,SELECT_BY_POS);
         if (OrderMagicNumber()==m){
            if (OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),Slippage,Pink);
            if (OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage,Pink);
            g=false;
            break;
         }
      }   
   }
}

int TotalOrders(int magic){
   int rez=0;
   for (int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS);
      if (OrderMagicNumber()==magic){
         rez++;
      }
   }   
   return(rez);
} 
double FRisk_MM(double SLot,double TR,double f){
   double rez=0;      
   rez=MathFloor((f*(AccountEquity()/TR)));        
   if (rez/10<SLot) return(SLot);
   return(rez/10);
}


string error(int err){
switch (err){
 case 0 :return("No error returned.");
 case 1 :return("No error returned, but the result is unknown. ");
 case 2 :return("Common error. ");
 case 3 :return("Invalid trade parameters. ");
 case 4 :return("Trade server is busy. ");
 case 5 :return("Old version of the client terminal. ");
 case 6 :return("No connection with trade server. ");
 case 7 :return("Not enough rights. ");
 case 8 :return("Too frequent requests."); 
 case 9 :return("Malfunctional trade operation. ");
 case 64 :return("Account disabled. ");
 case 65 :return("Invalid account. ");
 case 128 :return("Trade timeout. ");
 case 129 :return("Invalid price. ");
 case 130 :return("Invalid stops. ");
 case 131 :return("Invalid trade volume. ");
 case 132 :return("Market is closed. ");
 case 133 :return("Trade is disabled. ");
 case 134 :return("Not enough money. ");
 case 135 :return("Price changed. ");
 case 136 :return("Off quotes. ");
 case 137 :return("Broker is busy."); 
 case 138 :return("Requote. ");
 case 139 :return("Order is locked. ");
 case 140 :return("Long positions only allowed. ");
 case 141 :return("Too many requests. ");
 case 145 :return("Modification denied because order too close to market. ");
 case 146 :return("Trade context is busy. ");
 case 147 :return("Expirations are denied by broker. ");
 case 148 :return("The amount of open and pending orders has reached the limit set by the broker. ");
 case 4000 :return("No error. ");
 case 4001 :return("Wrong function pointer. ");
 case 4002 :return("Array index is out of range. ");
 case 4003 :return("No memory for function call stack. ");
 case 4004 :return("Recursive stack overflow. ");
 case 4005 :return("Not enough stack for parameter. ");
 case 4006 :return("No memory for parameter string. ");
 case 4007 :return("No memory for temp string. ");
 case 4008 :return("Not initialized string. ");
 case 4009 :return("Not initialized string in array. ");
 case 4010 :return("No memory for array string. ");
 case 4011 :return("Too long string. ");
 case 4012 :return("Remainder from zero divide. ");
 case 4013 :return("Zero divide. ");
 case 4014 :return("Unknown command. ");
 case 4015 :return("Wrong jump (never generated error). ");
 case 4016 :return("Not initialized array. ");
 case 4017 :return("DLL calls are not allowed. ");
 case 4018 :return("Cannot load library. ");
 case 4019 :return("Cannot call function. ");
 case 4020 :return("Expert function calls are not allowed. ");
 case 4021 :return("Not enough memory for temp string returned from function. ");
 case 4022 :return("System is busy (never generated error). ");
 case 4050 :return("Invalid function parameters count. ");
 case 4051 :return("Invalid function parameter value. ");
 case 4052 :return("String function internal error. ");
 case 4053 :return("Some array error. ");
 case 4054 :return("Incorrect series array using. ");
 case 4055 :return("Custom indicator error. ");
 case 4056 :return("Arrays are incompatible. ");
 case 4057 :return("Global variables processing error. ");
 case 4058 :return("Global variable not found. ");
 case 4059 :return("Function is not allowed in testing mode. ");
 case 4060 :return("Function is not confirmed. ");
 case 4061 :return("Send mail error. ");
 case 4062 :return("String parameter expected. ");
 case 4063 :return("Integer parameter expected. ");
 case 4064 :return("Double parameter expected. ");
 case 4065 :return("Array as parameter expected. ");
 case 4066 :return("Requested history data in updating state. ");
 case 4067 :return("Some error in trading function. ");
 case 4099 :return("End of file. ");
 case 4100 :return("Some file error."); 
 case 4101 :return("Wrong file name. ");
 case 4102 :return("Too many opened files. ");
 case 4103 :return("Cannot open file. ");
 case 4104 :return("Incompatible access to a file. ");
 case 4105 :return("No order selected. ");
 case 4106 :return("Unknown symbol. ");
 case 4107 :return("Invalid price. ");
 case 4108 :return("Invalid ticket. ");
 case 4109 :return("Trade is not allowed. ");
 case 4110 :return("Longs are not allowed. ");
 case 4111 :return("Shorts are not allowed. ");
 case 4200 :return("Object exists already. ");
 case 4201 :return("Unknown object property. ");
 case 4202 :return("Object does not exist. ");
 case 4203 :return("Unknown object type. ");
 case 4204 :return("No object name. ");
 case 4205 :return("Object coordinates error. ");
 case 4206 :return("No specified subwindow. ");
 case 4207 :return("Some error in object function. ");
 default: return("Unknown error:"+err);
}
}



